package com.springbootequestValidation.api.Controller;

import com.springbootequestValidation.api.dto.UserRequest;
import com.springbootequestValidation.api.entity.User;
import com.springbootequestValidation.api.exception.UserNotFoundException;
import com.springbootequestValidation.api.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/users")
public class UserController {
    @Autowired
    private UserService service;

    @PostMapping("/signup")
    public ResponseEntity<User> saveUser(@RequestBody @Valid  UserRequest useRequest) {
        return new ResponseEntity<>(service.saveUser(useRequest), HttpStatus.CREATED);

    }
@GetMapping("/fetchAll")
    public ResponseEntity<List<User>> getALLUsers() {
        return ResponseEntity.ok(service.getAllUsers());
    }
    public ResponseEntity<User> getUser(@PathVariable  int id) throws UserNotFoundException {
        return ResponseEntity.ok(service.getUser(id));

    }
}




